; ++++ Simple Registry Enumrator ++++
; ++++ Programmed by Luis Costa +++++
; +++++++ Lisbon,Portugal +++++++++++
; +++++++ xandaz@hotmail.com ++++++++

.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\advapi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\advapi32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

TreeViewID          equ     100h
ListViewID          equ     200h
NoSystemKeys        equ     4
.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Registry Viewer v1.0',0
wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ TreeView related ++++

TreeViewClass       db      'SysTreeView32',0
hTreeView           dd      ?
tvis        TV_INSERTSTRUCT     <>
tvi         TV_ITEM             <>

; ++++ ListView related ++++

ListViewClass       db      'SysListView32',0
hListView           dd      ?
lvi         LV_ITEM             <>

; ++++ Registry related ++++

SystemKeys      dd      HKEY_CLASSES_ROOT
                db      'HKEY_CLASSES_ROOT',0
                dd      HKEY_CURRENT_USER
                db      'HKEY_CURRHKEY_USERSENT_USER',0
                dd      HKEY_LOCAL_MACHINE
                db      'HKEY_LOCAL_MACHINE',0
                dd      HKEY_USERS
                db      'HKEY_USERS',0
                
szSubKey        db      256 dup(0)
                
; ++++ Other vars and structs ++++

rect        RECT        <>

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  InitCommonControls
            invoke  GetClientRect,hWnd,addr rect
            push    rect.right
            shr     rect.right,2
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr TreeViewClass,NULL,WS_VISIBLE+WS_CHILD+\
                        TVS_HASLINES+TVS_LINESATROOT+TVS_HASBUTTONS,0,0,rect.right,rect.bottom,\
                        hWnd,TreeViewID,hInstance,NULL
            mov hTreeView,eax
            mov     eax,rect.right
            add     eax,2
            pop     rect.right
            sub     rect.right,eax
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ListViewClass,NULL,WS_VISIBLE+WS_CHILD+\
                        LVS_REPORT,eax,0,rect.right,rect.bottom,\
                        hWnd,ListViewID,hInstance,NULL
            mov     hListView,eax
            call  FillTVControl
        .endif                                    
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

FillTVControl   PROC

    local   hKey:DWORD
    local   nIndex:DWORD

    mov     nIndex,0
    mov     tvis.hInsertAfter,NULL
    mov     tvis.item.imask,TVIF_TEXT+TVIF_PARAM
    mov     ecx,NoSystemKeys
    lea     esi,SystemKeys
    cld
loop_0:
    mov     tvis.hParent,NULL
    lodsd
    mov     tvis.item.lParam,eax
    mov     hKey,eax
    mov     tvis.item.pszText,esi
    push    ecx
    invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
    mov     tvis.hParent,eax
    mov     tvis.item.pszText,offset szSubKey
loop_1:
    invoke  RegEnumKey,hKey,nIndex,addr szSubKey,256
    cmp     eax,ERROR_SUCCESS
    jne     test_end
    invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
    inc     nIndex
    jmp     loop_1
test_end:
    pop     ecx
    dec     ecx
    jcxz    end_loops
realign_loop:
    lodsb
    cmp     al,0
    jne     realign_loop
    mov     nIndex,0
    jmp     loop_0
end_loops:
    ret                
    
FillTVControl   endp
end start                                            
